//+------------------------------------------------------------------+
//|                                                EVM+Fibo v6.0.mq4 |
//|                                     based on Equity_virtual1.mq4 |
//|                                         Copyright  2009, Xupypr |
//|                              http://www.mql4.com/ru/users/Xupypr |
//|                                               01.04.2009 |
//|                                       BasketBull |
//|                                                     2010 Yuritch |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Xupypr"
#property link      "http://www.mql4.com/ru/users/Xupypr"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 CLR_NONE

#property indicator_color2 Green
#property indicator_color4 Lime

#property indicator_color3 Crimson
#property indicator_color5 Red
#property indicator_color6 White

#property indicator_width1 0
#property indicator_width2 1
#property indicator_width3 1

#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

#property indicator_level1 0
#property show_inputs

extern datetime Time_Open=D'2011.01.01 00:00';  //    
extern bool     General_Line  =false; //  . -     /
extern bool     Monthly       =false; //  
extern bool     Weekly        =false; //  
extern bool     Daily         =true; //  
extern bool     Zero_point    =false;   //      (zero_point) 
extern bool     First_open    =false;   //      (   )
extern bool     Import        =false;       //     
extern double   Default_Lot=0.01;      //    ,        
datetime Time_Open1;

string   Buy_Symbols,Sell_Symbols,Symbols;

bool     Show_Total=true;  //   
bool     Show_Buy=true;   //    buy
bool     Show_Sell=true;  //    sell

int      Total;
bool     First;
double   TotalEquity[],BuyEquity[],SellEquity[];
double   Equity[],maxlong=0,maxshort=0;
double   Fat_BuyEquity[],Fat_SellEquity[],num_pair;

string   ShortName,suff="";

int      OpenBar;      //   
int      CloseBar;     //   
int      Type[];       //  
int      pairs;       // 
string   Instrument[]; // 
double   Lots[];       //  
double   OpenPrice[];  //  

//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
int init()
{
  if (StringLen(Symbol()) >6)
     {
     suff=StringSubstr(Symbol(),6,0);
     }
  else suff="";
     
  if (General_Line) { Monthly=false; Weekly=false; Daily=false; Zero_point=false; First_open=false;}
  if (Monthly) {Weekly=false; Daily=false; Zero_point=false; First_open=false;}
  if (Weekly) {Daily=false; Zero_point=false; First_open=false;}
  if (Daily) {Zero_point=false; First_open=false;}
  if (Zero_point) {First_open=false;}
 
                  
   ObjectsDeleteAll(-1,OBJ_FIBO);
   ObjectsDeleteAll(-1,OBJ_VLINE);
  if (GlobalVariableCheck("num_pair")) num_pair= GlobalVariableGet("num_pair");

 SetIndexBuffer(0,TotalEquity);
 SetIndexLabel(0,"Total");
// SetIndexStyle(0,DRAW_HISTOGRAM);
 SetIndexStyle(0, DRAW_LINE);

 SetIndexBuffer(1,BuyEquity);
 SetIndexLabel(1,"Buy "+Buy_Symbols);
 SetIndexStyle(1,DRAW_HISTOGRAM);

 SetIndexBuffer(2,SellEquity);
 SetIndexLabel(2,"Sell "+Sell_Symbols);
 SetIndexStyle(2,DRAW_HISTOGRAM);

//--N
 SetIndexBuffer(3,Fat_BuyEquity);
 SetIndexLabel(3,"Buy_Fat "+Buy_Symbols);
 SetIndexStyle(3,DRAW_HISTOGRAM);

 SetIndexBuffer(4,Fat_SellEquity);
 SetIndexLabel(4,"Sell_Fat "+Sell_Symbols);
 SetIndexStyle(4,DRAW_HISTOGRAM);

 SetIndexBuffer(5,Equity);
 SetIndexLabel(5,"Equity "+Sell_Symbols);
 SetIndexStyle(5, DRAW_LINE);

 ShortName="EVM+Fibo";

 IndicatorShortName(ShortName);
 IndicatorDigits(0);
 
 First=true;
 if (ObjectFind("openall")>=0) ObjectDelete("openall");
 return(0);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator deinit function                                          |
//+----------------------------------------------------------------------------+

int deinit() 
{
}
//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
int start()
{
  // GlobalVariableGet("reset") !=0
   if (Monthly||Weekly||Daily) 
      {
      if (Monthly) Time_Open1=iTime(NULL,43200,0);
      if (Weekly ) Time_Open1=iTime(NULL,10080,0);
      if (Daily) Time_Open1=iTime(NULL,1440,0);
      }
   else
      {
      if (General_Line==false)
         {
         if (Zero_point==true && First_open==false && GlobalVariableCheck("zero_point")) Time_Open1 = GlobalVariableGet("zero_point");
         }
      if (First_open==true && GlobalVariableCheck("opentime")) 
         {
         Time_Open1 = GlobalVariableGet("opentime");
         } 
      else 
         { 
         Time_Open1 = GlobalVariableGet("zero_point"); 
         }
      }

 static string minfosymbols="";
 double buyprofitloss,sellprofitloss,spread,lotsize;
 int bar,i,j;

   if ((Time_Open1 != Time_Open && General_Line==false) )
      {
      ObjectsDeleteAll(-1,OBJ_FIBO);
      Time_Open=Time_Open1;
      maxlong=0;
      maxshort=0;
      ObjectSet("openall",OBJPROP_TIME1,Time_Open);
      First=true;
      ArrayInitialize(TotalEquity,0.0);
      ArrayInitialize(BuyEquity,0.0);
      ArrayInitialize(SellEquity,0.0);
      ArrayInitialize(Fat_BuyEquity,0.0);
      ArrayInitialize(Fat_SellEquity,0.0);
      ArrayInitialize(Equity,0.0);
      }

 OpenBar=iBarShift(NULL,0,Time_Open,false);
 CloseBar=0;
 
  ObjectCreate("AutoFiboUp" , OBJ_FIBO, WindowFind(ShortName) ,Time[0] ,0,Time_Open,0);
  ObjectSet("AutoFiboUp",OBJPROP_BACK, 1);
  ObjectCreate("AutoFiboDn" , OBJ_FIBO, WindowFind(ShortName) , Time[0],0,Time_Open,0);
  ObjectSet("AutoFiboDn",OBJPROP_BACK, 1);
  
 if (First==true)
   {
   num_pair=GlobalVariableGet("num_pair");
   pairs=FileOpen("bbpairs", FILE_CSV|FILE_READ);
   Symbols="";
   for (i=0;i<num_pair;i++)
      {
      if (FileIsEnding(pairs)) break;
      Symbols = Symbols+FileReadString(pairs)+" ";
      }
   FileClose(pairs);
   Buy_Symbols=Symbols;
   Sell_Symbols=Symbols;
   Total=0;
   SetOrder(Buy_Symbols,OP_BUY);
   SetOrder(Sell_Symbols,OP_SELL);
   if (Total==0)
      {
      Print("  .   .");
      return(0);
      }
   else {First=false; Comment("");}
   }
   else
      {
      OpenBar=1;
      CloseBar=0;
      }

 for (i=OpenBar;i>=CloseBar;i--)
   {
   buyprofitloss=0.0;
   sellprofitloss=0.0;
   for (j=0;j<Total;j++)
      {
        if (MarketInfo(Instrument[j],MODE_POINT)==0)
         {
         if (StringFind(minfosymbols,Instrument[j])==-1)
            {
            Alert("     "+Instrument[j]);
            minfosymbols=StringConcatenate(minfosymbols," ",Instrument[j]);
            }
         continue;
         }
      
   spread=MarketInfo(Instrument[j],MODE_POINT)*MarketInfo(Instrument[j],MODE_SPREAD);
   bar=iBarShift(Instrument[j],0,Time[i]);
   lotsize=LotSize(Instrument[j],Time[i]);
     
   if (Type[j]==OP_BUY) 
      {
      if (i>0) buyprofitloss+=(iClose(Instrument[j],0,bar)-OpenPrice[j]-spread/2)*Lots[j]*lotsize;
      else buyprofitloss+= (MarketInfo(Instrument[j],MODE_ASK)-OpenPrice[j]-spread/2)*Lots[j]*lotsize;
      }
   else
      {
      sellprofitloss+=(OpenPrice[j]-iClose(Instrument[j],0,bar)-spread/2)*Lots[j]*lotsize;
      }
      } // for j
  if (Show_Total)
      {
      if (Equity[i] >0) TotalEquity[i]=  maxlong;
      else TotalEquity[i]= maxshort;
      }
//    TotalEquity[i]=NormalizeDouble(buyprofitloss+sellprofitloss,2);
  
  if (Show_Buy)  
      {
      BuyEquity[i] = NormalizeDouble(buyprofitloss,2);
      if (BuyEquity[i]<0)  BuyEquity[i]=0;
      else Equity[i] = BuyEquity[i];
      
      if (Import) maxlong = GlobalVariableGet("maxtotal_long");
      else if (BuyEquity[i]>maxlong) maxlong=BuyEquity[i];
 
      Fat_BuyEquity[i] = 0;
      if (BuyEquity[i] >= BuyEquity[i+1])
      Fat_BuyEquity[i] = BuyEquity[i];
      }
  if (Show_Sell)  
      {
      sellprofitloss=sellprofitloss*(-1);
      SellEquity[i]=NormalizeDouble(sellprofitloss,2);
      if (SellEquity[i]>0)  SellEquity[i]=0;
      else Equity[i] = SellEquity[i];
   
      if (Import) maxshort = GlobalVariableGet("maxtotal_short");
      else if  (SellEquity[i]<maxshort) maxshort=SellEquity[i];

      Fat_SellEquity[i] = 0;
      if (SellEquity[i] <= SellEquity[i+1])
      Fat_SellEquity[i] = SellEquity[i];
      }
  if (BuyEquity[i]>0 )
      {
       ObjectSet("AutoFiboUp", OBJPROP_PRICE1, NormalizeDouble(maxlong,0));
       ObjectSet("AutoFiboUp", OBJPROP_PRICE2, 0);
      }// else {ObjectDelete("AutoFiboUp"); }
   if (SellEquity[i]<0)
      {   
       ObjectSet("AutoFiboDn", OBJPROP_PRICE1, NormalizeDouble(maxshort,0));
       ObjectSet("AutoFiboDn", OBJPROP_PRICE2, 0);         
      }// else { ObjectDelete("AutoFiboDn"); }          
  }       
   for(j = 0; j < 8; j++)
     {
     ObjectSetFiboDescription("AutoFiboUp", j, DoubleToStr(ObjectGet("AutoFiboUp", OBJPROP_FIRSTLEVEL+j)*100,1) + "  %$");
     ObjectSetFiboDescription("AutoFiboDn", j, DoubleToStr(ObjectGet("AutoFiboDn", OBJPROP_FIRSTLEVEL+j)*100,1) + "  %$");
     } 

//---------------------
  if (ObjectFind("openall")==-1) 
  {
  ObjectCreate("openall",OBJ_VLINE,WindowFind(ShortName) ,Time_Open,0);
  ObjectSet("openall",OBJPROP_COLOR,DarkGray);
  }
  if (IsNewBar(1)) First=true;
  return(0);
}  
//-----------------------------

//+----------------------------------------------------------------------------+
//|                                                 |
//+----------------------------------------------------------------------------+
double LotSize(string symbol, datetime tbar)
{
   double size;
   string BQ,currency=AccountCurrency();
   switch (MarketInfo(symbol,MODE_PROFITCALCMODE))
      {
      case 0:
         {
         int sbar=iBarShift(symbol,0,tbar);
         size=MarketInfo(symbol,MODE_LOTSIZE);
         if (StringSubstr(symbol,3,3)=="USD") break;
         if (StringSubstr(symbol,0,3)=="USD") size=size/iClose(symbol,0,sbar);
         else
            {
            BQ=StringSubstr(symbol,0,3)+"USD";
            if (iClose(BQ,0,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
            if (iClose(BQ,0,0)==0) break;
            int BQbar=iBarShift(BQ,0,tbar);
            if (StringSubstr(BQ,0,3)=="USD") size=size/iClose(BQ,0,BQbar)/iClose(symbol,0,sbar);
            else size=size*iClose(BQ,0,BQbar)/iClose(symbol,0,sbar);
            }
         } break;
      case 1: size=MarketInfo(symbol,MODE_LOTSIZE); break;
      case 2: size=MarketInfo(symbol,MODE_TICKVALUE)/MarketInfo(symbol,MODE_TICKSIZE); break;
      }

 if (currency!="USD")
   {
   BQ=currency+"USD";
      if (iClose(BQ,0,0)==0)
      {
      BQ="USD"+currency;
      size*=iClose(BQ,0,iBarShift(BQ,0,tbar));
      }
      else size/=iClose(BQ,0,iBarShift(BQ,0,tbar));
   }
 return(size);
}
//+----------------------------------------------------------------------------+
//|                                                   |
//+----------------------------------------------------------------------------+
void SetOrder(string name, int cmd)
{
   int length,pos,end;
   double  minlot;
   
   if (Default_Lot==0) Default_Lot=MarketInfo(Symbol(), MODE_MINLOT);
      length=StringLen(name);
      pos=0;
      while (pos<length)
      {
      Total++;
      ArrayResize(Type,Total);
      ArrayResize(Instrument,Total);
      ArrayResize(Lots,Total);
      ArrayResize(OpenPrice,Total);
      Type[Total-1]=cmd;
      Instrument[Total-1]=StringSubstr(name,pos,6)+suff;
      pos+=6;
      if (StringGetChar(name,pos)==32 || (length-1)<pos) Lots[Total-1]=Default_Lot;
   else
      {
      end=0;
      while(StringGetChar(name,pos+end)!=32)
         {
         if ((length-1)<pos+end) break;
         end++;
         }
      Lots[Total-1]=StrToDouble(StringSubstr(name,pos,pos+end));
      pos+=end;
      }
      pos++;
      OpenPrice[Total-1]=iClose(Instrument[Total-1],0,iBarShift(Instrument[Total-1],0,Time_Open));
  //if (cmd==OP_BUY)   OpenPrice[Total-1]=MarketInfo(Instrument[Total-1],MODE_POINT)*MarketInfo(Instrument[Total-1],MODE_SPREAD);
      } //while
}
//+----------------------------------------------------------------------------+
//|                                                   |
//+----------------------------------------------------------------------------+
bool IsNewBar(int timeFrame)
   {
   bool res=false;
   
   static datetime _sTime[9]; //    ()   9 
   int i=8;
 
   switch (timeFrame) 
      {
      case 1  : i=0; break;
      case 5  : i=1; break;
      case 15 : i=2; break;
      case 30 : i=3; break;
      case 60 : i=4; break;
      case 240: i=5;break;
      case 1440:i=6;break;
      case 10080:i=7;break;
      case 43200:i=8;break;
      default:  timeFrame = 60;
      }

   if (_sTime[i]==0 || _sTime[i]!=iTime(NULL,timeFrame,0)) //     LONG
      {
      _sTime[i] = iTime(NULL,timeFrame,0);
      res=true;
      }
   return(res);   
}
//+----------------------------------------------------------------------------+